#!/usr/bin/ruby
# encoding: utf-8

def get_chooser_screen(fwdbutton, simulate)
	icon_theme = Gtk::IconTheme.default
	outer_box = Gtk::VBox.new(true, 10)
	outer_box.set_size_request(570, 400)
	radio = Array.new
	header = Gtk::Label.new("Welches Problem haben Sie?")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	radio[0] = Gtk::RadioButton.new("Windows startet nicht oder stürzt ab")
	radio[1] = Gtk::RadioButton.new(radio[0], "Wichtige Daten sind nicht mehr auffindbar")
	radio[2] = Gtk::RadioButton.new(radio[0], "Ich habe mein  Windows-Passwort vergessen")
	radio[3] = Gtk::RadioButton.new(radio[0], "Ich habe den Verdacht, dass ich einen Virus habe")
	radio[4] = Gtk::RadioButton.new(radio[0], "Ich möchte den Rechner saubermachen")
	radio[5] = Gtk::RadioButton.new(radio[0], "Ich möchte eine zuvor erstellte Sicherung zurückspielen")
	outer_box.pack_start(header, true, true, 0)
	# 0.upto(5) { |i| outer_box.pack_start(radio[i], true, false, 0) }

	button = Array.new
	0.upto(5) { |i| 
		button[i] = Gtk::Button.new
		button[i].xalign = 0.0 
	}
	button[0].label = "Windows startet nicht oder stürzt ab"
	button[0].image = Gtk::Image.new(icon_theme.load_icon("gtk-stop", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	button[1].label = "Wichtige Daten sind nicht mehr auffindbar"
	button[1].image = Gtk::Image.new(icon_theme.load_icon("gnome-searchtool", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	button[2].label = "Ich habe mein  Windows-Passwort vergessen"
	button[2].image = Gtk::Image.new(icon_theme.load_icon("system-users", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	button[3].label = "Ich habe den Verdacht, dass ich einen Virus habe"
	button[3].image = Gtk::Image.new(icon_theme.load_icon("help-browser", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	button[4].label = "Ich möchte den Rechner saubermachen"
	button[4].image = Gtk::Image.new(icon_theme.load_icon("editclear", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	button[5].label = "Ich möchte eine zuvor erstellte Sicherung zurückspielen" 
	button[5].image = Gtk::Image.new(icon_theme.load_icon("gtk-redo-ltr", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	0.upto(5) { |i| 
		# button[i].height_request = 60
		outer_box.pack_start(button[i], true, true, 00)
	}
	
	return outer_box, radio, button
end

def get_failure_screen(fwdbutton, simulate)
	icon_theme = Gtk::IconTheme.default
	outer_box = Gtk::VBox.new(true, 10)
	outer_box.set_size_request(570, 220)
	radio = Array.new
	header = Gtk::Label.new("Windows startet nicht richtig oder stürzt ab")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	radio[0] = Gtk::RadioButton.new("Windows startet vollständig, stürzt aber ab oder friert ein")
	radio[1] = Gtk::RadioButton.new(radio[0], "Windows startet nicht, es erscheint \"NTLDR nicht gefunden\"")
	radio[2] = Gtk::RadioButton.new(radio[0], 
		"Windows startet nicht, es erscheint \"No operating system found\" oder \"Please insert a bootable media\"")
	outer_box.pack_start(header, true, true, 0)
	# 0.upto(2) { |i| outer_box.pack_start(radio[i], true, false, 0) }
	
	button = Array.new
	0.upto(2) { |i| 
		button[i] = Gtk::Button.new
		button[i].xalign = 0.0 
	}
	button[0].label = "Windows startet vollständig, stürzt aber ab oder friert ein"
	button[0].image = Gtk::Image.new(icon_theme.load_icon("gnome-monitor", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	button[1].label = "Windows startet nicht, es erscheint \"NTLDR nicht gefunden\""
	button[1].image = Gtk::Image.new(icon_theme.load_icon("help-browser", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	b2l = Gtk::Label.new "Windows startet nicht, es erscheint \"No operating system found\" oder \"Please insert a bootable media\""
	b2l.wrap = true
	lbx = Gtk::Alignment.new(0.0, 0.0, 1.0, 1.0)
	lbx.add b2l
	# button[2].add b2l
	aux_hb =  Gtk::HBox.new(false, 4)
	aux_hb.pack_start( Gtk::Image.new(icon_theme.load_icon("gtk-floppy", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK)), false, true, 0)
	aux_hb.pack_start( lbx, false, true, 0)
	# button[2].image = Gtk::Image.new(icon_theme.load_icon("system-users", 48, Gtk::IconTheme::LOOKUP_GENERIC_FALLBACK))
	button[2].add aux_hb
	0.upto(2) { |i| outer_box.pack_start(button[i], true, true, 0) }
	return outer_box, radio, button
end

def get_photorec_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	radio = Array.new
	header = Gtk::Label.new("Wichtige Daten sind nicht mehr auffindbar")
	desc = Gtk::Label.new("Auf welchem Laufwerk wollen Sie nach den verlorenen Daten suchen? Das gesamte Laufwerk wird durchsucht.")
	desc.wrap = true
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	drive_combo = Gtk::ComboBox.new
	reread = Gtk::Button.new("Neu einlesen")
	inner_box = Gtk::HBox.new(false, 0)
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	inner_box.pack_start(drive_combo, true, true, 0)
	inner_box.pack_start(reread, true, true, 0)
	outer_box.pack_start(inner_box, true, true, 0)
	return outer_box, drive_combo, reread
end

def getChntpwScreen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	radio = Array.new
	header = Gtk::Label.new("Ich habe mein Windows-Passwort vergessen")
	desc = Gtk::Label.new("Von welcher Windows-Installation soll die Passwort-Datei bearbeitet werden?")
	desc.wrap = true
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	drive_combo = Gtk::ComboBox.new
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(drive_combo, true, true, 0)
	return outer_box, drive_combo
end

def get_virus_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Ich habe den Verdacht, dass ich einen Virus habe")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Es wurde keine nutzbare Internetverbindung entdeckt. Bitte tragen Sie die Zugangsdaten für Ihr WLAN ein oder wählen Sie \"Ohne Signaturupdate fortfahren\".")
	desc.wrap = true
	goon = Gtk::Label.new("Klicken Sie anschließend auf \"Weiter\" um die Aktualisierung der Virensignaturen zu starten.")
	goon.wrap = true
	netcombo = Gtk::ComboBoxEntry.new
	netkey = Gtk::Entry.new
	netkey.visibility = false
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	ssid_box = Gtk::HBox.new(true, 0)
	ssid_box.pack_start(Gtk::Label.new("Funknetzwerk"), true, true, 0)
	ssid_box.pack_start(netcombo, true, true, 0)
	outer_box.pack_start(ssid_box, true, true, 0)
	key_box = Gtk::HBox.new(true, 0)
	key_box.pack_start(Gtk::Label.new("Schlüssel"), true, true, 0)
	key_box.pack_start(netkey, true, true, 0)
	outer_box.pack_start(key_box, true, true, 0)
	skip_wlan = Gtk::CheckButton.new("Ohne Signaturaktualisierung fortfahren")
	outer_box.pack_start(skip_wlan, true, true, 0)
	return outer_box, netcombo, netkey, skip_wlan
end

def getCleanScreen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	radio = Array.new
	header = Gtk::Label.new("Ich möchte den Rechner saubermachen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	radio[0] = Gtk::RadioButton.new("Schnell: Für Neuinstallation von Windows")
	radio[1] = Gtk::RadioButton.new(radio[0], "Sicher: Für Weitergabe eines Computers/Datenträgers")
	outer_box.pack_start(header, true, false, 0)
	0.upto(2) { |i| outer_box.pack_start(radio[i], true, false, 0) }
	return outer_box, radio
end

def getRestoreScreen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	radio = Array.new
	header = Gtk::Label.new("Ich möchte eine zuvor erstellte Sicherung zurückspielen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Bitte wählen Sie das Quelllaufwerk, auf dem sich Ihre Datensicherung befindet.")
	desc.wrap = true
	drive_combo = Gtk::ComboBox.new
	reread = Gtk::Button.new("Neu einlesen")
	inner_box = Gtk::HBox.new(false, 0)
	inner_box.pack_start(drive_combo, true, true, 0)
	inner_box.pack_start(reread, true, true, 0)
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(inner_box, true, true, 0)
	return outer_box, drive_combo, reread
end

def get_photorec_types_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Auswahl der Dateitypen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	# scroll_pane = Gtk::ScrolledWindow.new
	# scroll_pane.set_size_request(400, 250)
	desc = Gtk::Label.new("Nach welchen Dateitypen soll gesucht werden?")
	filetypes = Array.new
	filetypes[0] = Gtk::CheckButton.new("Office-Dateien")
	filetypes[1] = Gtk::CheckButton.new("Fotos")
	filetypes[2] = Gtk::CheckButton.new("Filme")
	filetypes[3] = Gtk::CheckButton.new("Audio-Dateien")
	filetypes[4] = Gtk::CheckButton.new("Postfach-Dateien")
	filetypes[5] = Gtk::CheckButton.new("Archivdateien (Zip, ISO)")
	filetypes.each { |f| f.active = true } 
	fmachine = [ "office", "image", "video", "audio", "mail", "archive" ]
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	0.upto(5) { |i| outer_box.pack_start(filetypes[i], true, false, 0) }
	return outer_box, filetypes, fmachine
end


def get_photorec_target_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	radio = Array.new
	header = Gtk::Label.new("Auswahl des Ziellaufwerkes")
	desc = Gtk::Label.new("Wohin sollen gefundene Dateien gespeichert werden? Es werden nur Laufwerke mit wenigstens einem Gigabyte freiem Speicher angezeigt.")
	desc.wrap = true
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	drive_combo = Gtk::ComboBox.new
	reread = Gtk::Button.new("Neu einlesen")
	inner_box = Gtk::HBox.new(false, 0)
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	inner_box.pack_start(drive_combo, true, true, 0)
	inner_box.pack_start(reread, true, true, 0)
	outer_box.pack_start(inner_box, true, true, 0)
	return outer_box, drive_combo, reread
end

def get_photorec_prog_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Suche nach Dateien")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Gefundene Dateien: 23")
	pgbar = Gtk::ProgressBar.new
	pgbar.width_request = 300
	scan_vte = Vte::Terminal.new
	scan_exp = Gtk::Expander.new("Details anzeigen")
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(pgbar, true, true, 0)
	scan_exp.add(scan_vte)
	outer_box.pack_start(scan_exp, true, true, 0)
	return outer_box, scan_vte, pgbar
end
	
def getChntpwUserScreen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Auswahl des Nutzers")
	desc = Gtk::Label.new("Wählen Sie den Nutzer aus, dessen Passwort zurückgesetzt werden soll.")
	desc.wrap = true
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	user_combo = Gtk::ComboBox.new
	user_combo.append_text("Administrator")	
	user_combo.active = 0
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(user_combo, true, true, 0)
	return outer_box, user_combo
end
	
def get_virus_sig_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Aktualisierung der Virussignaturen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Heruntergeladene Dateien: 23")
	pgbar = Gtk::ProgressBar.new
	pgbar.width_request = 300
	scan_vte = Vte::Terminal.new
	scan_exp = Gtk::Expander.new("Details anzeigen")
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(pgbar, true, true, 0)
	scan_exp.add(scan_vte)
	outer_box.pack_start(scan_exp, true, true, 0)
	return outer_box, scan_vte, pgbar
end

def get_virus_scan_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Suche nach Viren und anderer Schadsoftware")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Gefundene verdächtige Dateien: 42")
	pgbar = Gtk::ProgressBar.new
	pgbar.width_request = 300
	scan_vte = Vte::Terminal.new
	scan_exp = Gtk::Expander.new("Details anzeigen")
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(pgbar, true, true, 0)
	scan_exp.add(scan_vte)
	outer_box.pack_start(scan_exp, true, true, 0)
	return outer_box, scan_vte, pgbar
end

def get_virus_results_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Ergebnisse des Virenscans")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc1 = Gtk::Label.new("15 Infizierte Dateien gefunden")
	act = Gtk::Label.new("Klicken Sie auf \"Weiter\", um die infizierten Dateien zu reparieren. Ist keine Reparatur möglich, erfolgt eine Umbenennung.")
	act.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc1, true, true, 0)
	outer_box.pack_start(act, true, true, 0)
	return outer_box
end

def get_virus_repair_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Reparatur infizierter Dateien")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Reparierte Dateien: 42")
	pgbar = Gtk::ProgressBar.new
	pgbar.width_request = 300
	scan_vte = Vte::Terminal.new
	scan_exp = Gtk::Expander.new("Details anzeigen")
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(pgbar, true, true, 0)
	scan_exp.add(scan_vte)
	outer_box.pack_start(scan_exp, true, true, 0)
	return outer_box, scan_vte
end

def get_virus_finish_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Reparatur abgeschlossen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Die Reparatur infizierter Dateien ist abgeschlossen. Klicken Sie auf \"Weiter\", um Ihren Computer neu zu starten.")
	desc.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def get_clean_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Auswahl der Laufwerke")
	desc = Gtk::Label.new("Welche Laufwerke sollen gelöscht werden?")
	desc.wrap = true
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	drivebox = Gtk::VBox.new(false, 5)
	scroll_pane = Gtk::ScrolledWindow.new
	scroll_pane.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
	scroll_pane.add_with_viewport(drivebox)
	scroll_pane.set_size_request(480, 300)
	
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(scroll_pane, true, false, 0)
	return outer_box, drivebox
end


def get_clean_progress_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Löschen von Datenträgern")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	drivebox = Gtk::VBox.new(false, 5)
	scroll_pane = Gtk::ScrolledWindow.new
	scroll_pane.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
	scroll_pane.add_with_viewport(drivebox)
	scroll_pane.set_size_request(480, 300)
	
	outer_box.pack_start(header, true, false, 0)
	# outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(scroll_pane, true, false, 0)
	return outer_box, drivebox
	# return outer_box, scan_vte, pgbar
end

def get_clean_finish_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Löschen abgeschlossen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Das Löschen Ihrer Festplatte(n) ist abgeschlossen. Klicken Sie auf \"Weiter\", um Ihren Computer neu zu starten.")
	desc.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def get_restore_target_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	radio = Array.new
	header = Gtk::Label.new("Auswahl des Ziellaufwerkes")
	desc = Gtk::Label.new("Auf welche Festplatte soll die Sicherung zurückgespielt werden?")
	desc.wrap = true
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	drive_combo = Gtk::ComboBox.new
	reread = Gtk::Button.new("Neu einlesen")
	inner_box = Gtk::HBox.new(false, 0)
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	inner_box.pack_start(drive_combo, true, true, 0)
	inner_box.pack_start(reread, true, true, 0)
	outer_box.pack_start(inner_box, true, true, 0)
	return outer_box, drive_combo, reread
end

def get_restore_progress_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Zurückkopieren einer Datensicherung")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Fortschritt: 42%")
	pgbar = Gtk::ProgressBar.new
	pgbar.width_request = 300
	scan_vte = Vte::Terminal.new
	scan_vte.set_size(80, 15)
	scan_exp = Gtk::Expander.new("Details anzeigen")
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(pgbar, true, true, 0)
	scan_exp.add(scan_vte)
	outer_box.pack_start(scan_exp, true, true, 0)
	return outer_box, scan_vte, pgbar
end

def get_restore_finish_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Zurückkopieren abgeschlossen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Das Zurückkopieren der Datensicherung ist abgeschlossen. Klicken Sie auf \"Weiter\", um Ihren Computer neu zu starten.")
	desc.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def get_ntldr_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("NTLDR not found")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Ursache für den Fehler \"NTLDR not found\" sind meist defekte Festplatten oder defekter Arbeitsspeicher. Im weiteren Verlauf wird versucht, die Ursache exakt zu identifizieren. Notieren Sie sich die folgenden Hinweise, um nach Abschluss der Tests den NTLDR mit Hilfe der Windows-Installations-CD neu zu schreiben.")
	desc.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	xphead = Gtk::Label.new("Windows XP")
	xphead.modify_font(fat_font)
	visthead = Gtk::Label.new("Windows Vista und Windows 7")
	visthead.modify_font(fat_font)
	xptext = Gtk::Label.new("Blubberblah...")
	xptext.wrap = true
	visttext = Gtk::Label.new("Blubberblah...")
	visttext.wrap = true
	[ xphead, xptext, visthead, visttext ].each { |i|
		outer_box.pack_start(i, true, false, 0)
	}
	return outer_box
end

def get_noos_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("No operating system found")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Klicken Sie auf \"Weiter\" um die Startinformationen wiederherzustellen.")
	desc.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def get_noos_repaired_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Startinformationen wiederhergestellt")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Die Startinformationen wurden wiederhergestellt. Klicken Sie auf \"Weiter\", um den Computer neu zu starten. Sollte nach dem Neustart keine Besserung erkennbar sein, starten Sie diese CD erneut und wählen Sie den Punkt \"Wichtige Daten sind abhanden gekommen\"")
	desc.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def get_noos_failure_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Wiederherstellung Startinformationen fehlgeschlagen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Die Startinformationen konnten nicht wiederhergestellt werden. Ursache ist eine beschädigte Partitionstabelle/fehlgeschlagener Zugriff auf die als aktiv markierte Partition. Sichern Sie wichtige Daten und installieren Sie Windows neu. Klicken Sie auf \"Weiter\", um den Computer neu zu starten.")
	desc.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def reread_full_drives(combo, drives_to_ignore)
	drive_meta = Hash.new
	retdrives = Array.new
	99.downto(0) { |i|
		begin
			combo.remove_text(i)
		rescue
		end
	}
	alldrives = AllDrives.new(false, false, false)
	alldrives.dump 
	alldrives.drive_list.each { |k,d|
		unless drives_to_ignore.include?(k)
			retdrives.push(k)
			combo.append_text(d.device + " " + d.vendor + " " + d.model + " " + (d.blocks * d.bs / 1073741824).to_s + "GB")
			drive_meta[k] = d
		end
	}
	combo.active = 0
	return retdrives, drive_meta
end

def dialog_clone_compare(parent, clone_target, clone_source)
	msg = ""
	moveon = false
	if clone_source.last_partend < 0 && clone_target.size < clone_source.size
		msg = "Das Quelllaufwerk enthält keine Partitionstabelle und ist größer als das Ziellaufwerk - es ist möglich, dass beim Kopieren Daten verloren gehen."
	elsif clone_source.last_partend > clone_target.size
		msg = "Die letzte Partition des Quellaufwerkes liegt hinter dem Ende des Ziellaufwerkes. Es ist möglich, dass beim Kopieren Daten dieser Partition verloren gehen. Wir empfehlen, das Klonen abzubrechen und die letzte Partition des Quelllaufwerkes zunächst zu verkleinern."
	end	
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
		[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]	
	)
	dialog.default_response = Gtk::Dialog::RESPONSE_CANCEL
	dialog.has_separator = false
	label = Gtk::Label.new(msg)
	label.wrap = true
	# image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)
	# hbox = Gtk::HBox.new(false, 5)
	# hbox.border_width = 10
	# hbox.pack_start_defaults(image)
	# hbox.pack_start_defaults(label)
	dialog.vbox.add(label)
	warn = Gtk::Label.new("Wenn Sie auf \"OK\" klicken, werden alle Daten auf dem Ziellaufwerk überschrieben. Klicken Sie auf \"Abbrechen\" um zurück zur Laufwerksauswahl zu gelangen.")
	warn.wrap = true
	dialog.vbox.add(warn)
	dialog.show_all
	dialog.run { |resp|
		if resp == Gtk::Dialog::RESPONSE_OK
			moveon = true
		end
		dialog.destroy
	}
	return moveon
end

def fill_clean_list(box, type)
	box.each { |c| box.remove(c) }
	alldrives = AllDrives.new(true, true, false)
	drivelist = alldrives.drive_list
	all_checkboxes = Hash.new
	radio = Array.new
	fat_font = Pango::FontDescription.new("Sans Bold")
	drivelist.keys.sort.each { |k|
		v = drivelist[k]
		parts = Hash.new
		devices = Array.new
		0.upto(99) { |i|
			unless v.partitions[i].nil? || v.partitions[i].extended == true # || v.partitions[i].fs.to_s == ""
				p_desc = "Partition " + i.to_s + " " + (v.partitions[i].size/1024/1024).to_s + "MB " + v.partitions[i].fs.to_s 
				p_desc = p_desc + " Label: " + v.partitions[i].fslabel unless v.partitions[i].fslabel.to_s == "" 
				p_click = Gtk::CheckButton.new(p_desc)
				parts[v.partitions[i].id] = p_click
				# devices.push(v.partitions[i].id)
				# drivebox.pack_start(p_click, false, true, 5 )
			end
		}
		if parts.size > 0 && type == "fast"
			l = Gtk::Label.new(v.vendor + " " + v.model + " " + (v.blocks * v.bs / 1024 / 1024 ).to_s + "MB " + v.attached + " " + v.device  )
			l.modify_font(fat_font)
			box.pack_start(l, false, true, 5)
			parts.keys.sort.each { |p| 
				box.pack_start(parts[p], false, true, 5 ) 
				all_checkboxes[p] = parts[p] 
			}
		elsif type == "full"
			p_click = Gtk::CheckButton.new(v.vendor + " " + v.model + " " + 
				(v.blocks * v.bs / 1024 / 1024 ).to_s + "MB " + v.attached + " " + v.device )
			box.pack_start(p_click, false, true, 5 ) 
			all_checkboxes[v.device] = p_click 
		end
	}
	return all_checkboxes, alldrives
end

def fill_clean_pgbars(box, type, drivelist)
	box.each { |c| box.remove(c) }
	progress_bars = Hash.new
	parts = Hash.new
	devices = Array.new
	vtes = Hash.new
	drivelist.drive_list.keys.sort.each { |k|
		v = drivelist.drive_list[k]
		if type == "full"
			box.pack_start(Gtk::Label.new(k), false, true, 5)
			progress_bars[k] = Gtk::ProgressBar.new
			progress_bars[k].width_request = 300
			box.pack_start(progress_bars[k], false, true, 5)
			vtes[k] = Vte::Terminal.new
		elsif type == "fast"
			0.upto(99) { |i|
				unless v.partitions[i].nil? || v.partitions[i].extended == true # || v.partitions[i].fs.to_s == ""	
					p_desc = "Partition " + i.to_s + " " + (v.partitions[i].size/1024/1024).to_s + "MB " + v.partitions[i].fs.to_s 
					p_desc = p_desc + " Label: " + v.partitions[i].fslabel unless v.partitions[i].fslabel.to_s == "" 
					box.pack_start(Gtk::Label.new(p_desc), false, true, 5)
					progress_bars[v.device.to_s + i.to_s] = Gtk::ProgressBar.new
					progress_bars[v.device.to_s + i.to_s].width_request = 300
					box.pack_start(progress_bars[v.device.to_s + i.to_s], false, true, 5)
					vtes[v.device.to_s + i.to_s] = Vte::Terminal.new
				end
			}
		end
	}
	return progress_bars, vtes
end


def dialog_empty_clean(parent)
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
	)
	dialog.has_separator = false
	label = Gtk::Label.new("Bitte Laufwerke zum Löschen auswählen!")
	image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)

	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	hbox.pack_start_defaults(image);
	hbox.pack_start_defaults(label);

	# Add the message in a label, and show everything we've added to the dialog.
	# dialog.vbox.pack_start_defaults(hbox) # Also works, however dialog.vbox
                                          # limits a single item (element).
	dialog.vbox.add(hbox)
	dialog.show_all
	dialog.run
	dialog.destroy

end

def dialog_clean_warn(parent, type)
	msg = ""
	moveon = false
	if type == "fast"
		msg = "Die Schnellöschung wird einige Minuten dauern. Nach der Schnelllöschung ist es meist möglich, Teile der überschriebenen Daten wieder herzustellen. Verwenden Sie die Schnelllöschung daher nicht, wenn Sie einen Computer weitergeben möchten."
	elsif type == "full"
		msg = "Die sichere Löschung wird einige Stunden dauern. Nach der sicheren Löschung ist es in der Regel unmöglich, die überschriebenen Daten wiederherzustellen. Klicken Sie auf \"OK\", wenn Sie die ausgewählten Laufwerke unwiederbringlich löschen wollen."
	end	
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
		[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]	
	)
	dialog.default_response = Gtk::Dialog::RESPONSE_CANCEL
	dialog.has_separator = false
	label = Gtk::Label.new(msg)
	label.wrap = true
	dialog.vbox.add(label)
	dialog.show_all
	dialog.run { |resp|
		if resp == Gtk::Dialog::RESPONSE_OK
			moveon = true
		end
		dialog.destroy
	}
	return moveon
end

def find_win_sysparts(drives)
	sysparts = Hash.new
	drives.drive_list.keys.sort.each { |k|
		v = drives.drive_list[k]
		drives.drive_list[k].partitions.each { |l,p|
			if p.fs == "ntfs" || p.fs.downcase =~ /^fat/
				puts p.id
				system("umount " + p.id)
				system("mkdir -p /var/run/lesslinux/" + $$.to_s + "/testmount") unless 
					File.exist?("/var/run/lesslinux/" + $$.to_s + "/testmount")
				if p.fs == "ntfs"
					system("mount -t ntfs-3g -o ro " +  p.id + " /var/run/lesslinux/" + $$.to_s + "/testmount")
				else
					system("mount -t vfat -o ro " +  p.id + " /var/run/lesslinux/" + $$.to_s + "/testmount")
				end
				system("df -h /var/run/lesslinux/" + $$.to_s + "/testmount")
				if File.exist?("/var/run/lesslinux/" + $$.to_s + "/testmount/Windows/System32/config/SAM")
					sysparts[p.id] = v.vendor + " " + v.model + " Partition " + p.id + " " + (p.size / 1048576).to_s + "MB"
					puts sysparts[p.id]
				end
				system("umount /var/run/lesslinux/" + $$.to_s + "/testmount")
			end
		}
	}
	return sysparts
end

def fill_chntpw_combo(chntpw_combo, sysparts) 
	devices = Array.new
	100.downto(0) { |i| 
		begin
			chntpw_combo.remove_text(i) 
		rescue
		end
	}
	sysparts.each { |k,v|
		chntpw_combo.append_text(v)
		devices.push(k)
	}
	if sysparts.size < 1
		chntpw_combo.append_text("Keine Windows-Installation gefunden")
		chntpw_combo.sensitive = false
	end
	chntpw_combo.active = 0
	return devices
	
end

def get_nt_users(partition, drives)
	drives.drive_list.each { |k,d|
		d.partitions.each { |l,p|
			if p.id == partition
				if p.fs == "ntfs"
					system("mount -t ntfs-3g -o ro " +  partition + " /var/run/lesslinux/" + $$.to_s + "/testmount")	
				else
					system("mount -t vfat -o ro " +  partition + " /var/run/lesslinux/" + $$.to_s + "/testmount")
				end
			end
		}
	}
	samusers = Array.new
	IO.popen("chntpw -l /var/run/lesslinux/" + $$.to_s + "/testmount/Windows/System32/config/SAM") { |io|
		accstart = false
		while io.gets
			toks = $_.split("|")
			if accstart == true
				$stderr.puts "Hex ID:" + toks[1].to_s.strip
				$stderr.puts "Username: " + toks[2].to_s.strip.gsub(/[^[:print:]]/, '_')
				samusers.push( [ toks[1].to_s.strip, toks[2].to_s.strip.gsub(/[^[:print:]]/, '_') ] )
			end
			accstart = true if $_ =~ / ^|\sRID/
		end
	}
	system("umount /var/run/lesslinux/" + $$.to_s + "/testmount")
	return samusers
end

def fill_ntuser_combo(user_combo, ntusers)
	100.downto(0) { |i| 
		begin
			user_combo.remove_text(i) 
		rescue
		end
	}
	ntusers.each { |i|
		user_combo.append_text(i[1]) 
	}
	user_combo.active = 0
end

def get_chntpw_finish_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Passwort zurückgesetzt")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Das Windows-Passwort wurde erfolgreich zurückgesetzt.")
	desc.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end
	
def fill_photorec_combo(combo, drives)
	device_list = Array.new
	100.downto(0) { |i| 
		begin
			combo.remove_text(i) 
		rescue
		end
	}
	drives.drive_list.keys.sort.each { |k|
		v = drives.drive_list[k]
		label = v.vendor + " " + v.model + " " + (v.blocks * v.bs / 1024 / 1024 ).to_s + "MB " + v.attached + " " + v.device
		combo.append_text(label)
		device_list.push(v.device)
	}
	combo.active = 0
	return device_list
end

def run_chntpw(partition, user, drives)
	puts partition
	puts user.join(", ")
	drives.drive_list.each { |k,d|
		d.partitions.each { |l,p|
			if p.id == partition
				if p.fs == "ntfs"
					system("mount -t ntfs-3g -o rw " +  partition + " /var/run/lesslinux/" + $$.to_s + "/testmount")	
				else
					system("mount -t vfat -o rw " +  partition + " /var/run/lesslinux/" + $$.to_s + "/testmount")
				end
			end
		}
	}
	exstring = "printf \"1\\ny\\n\" | chntpw -u 0x" + user[0] + " /var/run/lesslinux/" + $$.to_s + "/testmount/Windows/System32/config/SAM"
	puts exstring
	retval = system(exstring)
	system("umount /var/run/lesslinux/" + $$.to_s + "/testmount")
	puts retval.to_s
	return retval
end

def dialog_photorec_notypes(parent)
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
	)
	dialog.has_separator = false
	label = Gtk::Label.new("Bitte Dateitypen zur Suche auswählen!")
	image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)

	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	hbox.pack_start_defaults(image);
	hbox.pack_start_defaults(label);

	# Add the message in a label, and show everything we've added to the dialog.
	# dialog.vbox.pack_start_defaults(hbox) # Also works, however dialog.vbox
                                          # limits a single item (element).
	dialog.vbox.add(hbox)
	dialog.show_all
	dialog.run
	dialog.destroy
end

def dialog_photorec_notarget(parent)
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
	)
	dialog.has_separator = false
	label = Gtk::Label.new("Kein Ziellaufwerk angegeben! Bitte schließen Sie ein Laufwerk an und drücken Sie dann den Knopf \"Neu einlesen\".")
	label.wrap = true
	image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)

	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	hbox.pack_start_defaults(image);
	hbox.pack_start_defaults(label);

	# Add the message in a label, and show everything we've added to the dialog.
	# dialog.vbox.pack_start_defaults(hbox) # Also works, however dialog.vbox
                                          # limits a single item (element).
	dialog.vbox.add(hbox)
	dialog.show_all
	dialog.run
	dialog.destroy
end

def fill_photorec_targets(combo, drives, source, minfree=100_000_000)
	device_list = Array.new
	100.downto(0) { |i| 
		begin
			combo.remove_text(i) 
		rescue
		end
	}
	drives.drive_list.keys.sort.each { |k|
		v = drives.drive_list[k]
		unless v.device == source
			v.partitions.each { |n,m|
				if (m.fs == "ntfs" || m.fs =~ /^fat/ || m.fs =~ /^ext/ || m.fs =~ /^btrfs/) && 
					m.mounted == false && m.free_space > minfree
					label = v.vendor + " " + v.model + " " + v.attached + 
						" Partition: " + v.device + n.to_s + " Frei: " + (m.free_space / 1048576).to_s + "MB"
					combo.append_text(label)
					device_list.push(m.id)
				end
			}
		end
	}
	combo.active = 0
	return device_list
end	

def run_photorec(source, categories, target, drives, vte, forw_button, progbar, parent)
	drives.drive_list.keys.sort.each { |k|
		v = drives.drive_list[k]
		v.partitions.each { |n,m|
			if m.id == target
				puts "Mounting target " + target + " FS: " + m.fs
				system("mkdir -p /var/run/lesslinux/" + $$.to_s + "/photorec_target")
				if m.fs == "ntfs"
					system("mount -t ntfs-3g -o rw " + target + " /var/run/lesslinux/" + $$.to_s + "/photorec_target")
				elsif m.fs =~ /^fat/
					system("mount -t vfat -o rw " + target + " /var/run/lesslinux/" + $$.to_s + "/photorec_target")
				else	
					system("mount -o rw " + target + " /var/run/lesslinux/" + $$.to_s + "/photorec_target")
				end
			end
		}
	}
	return false unless system("mountpoint -q /var/run/lesslinux/" + $$.to_s + "/photorec_target")
	forw_button.sensitive = false
	rescue_running = true
	# vte.fork_command("bash", [ "bash", "./run_chntpw.sh"])
	# "photorec /d \"" + target + "\" /cmd " + device + " " + partstring + ",fileopt,everything," + fileopt + "search"
	sleep_counter = 0
	recupdir = Time.now.strftime("Recovery-%Y%m%d-%H%M%S")
	params = [ "photorec", "/d", 
		"/var/run/lesslinux/" + $$.to_s + "/photorec_target/"+ recupdir , "/cmd", source,
		"partition_none,fileopt," + get_photorec_fileopts(categories) + ",search" ]
	puts params.join(" ")
	vte.fork_command("photorec", params )
	vte.signal_connect("child_exited") { rescue_running = false }
	auxiliary_drive = nil
	while rescue_running == true
		progbar.pulse
		while (Gtk.events_pending?)
			Gtk.main_iteration
		end
		if sleep_counter % 50 == 0
			# Check for free space!
			df_out = ` df -k #{target} | tail -n1 `
			freespace = df_out.split[3].to_i
			# FIXME: Move this out?
			# auxiliary_drive = nil
			if freespace < 100_000 && auxiliary_drive.nil?
				puts "Space is getting narrow, please STOP, clean up and CONT!"
				system("killall -STOP photorec")
				# dialog for copying
				copy_and_goon = dialog_photorec_space(parent)
				# dialog_move_recovered("/var/run/lesslinux/" + $$.to_s + "/photorec_target/", recupdir)
				if copy_and_goon == true
					cancel, auxiliary_drive = dialog_photorec_newtarget(parent, source)
					if cancel == false
						move_success = photorec_move_found(recupdir, auxiliary_drive)
						system("killall -CONT photorec")
					else
						system("killall -9 photorec")
					end
				else
					system("killall -9 photorec")
				end
			elsif freespace < 100_000
				system("killall -STOP photorec")
				unless photorec_move_found(recupdir, auxiliary_drive)
					auxiliary_drive = nil
				else
					system("killall -CONT photorec")
				end
			end
		end
		sleep 0.1
		sleep_counter += 1
	end
	system("umount /var/run/lesslinux/" + $$.to_s + "/photorec_target")
	forw_button.sensitive = true
	return true
end

def get_photorec_finish_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 0)
	header = Gtk::Label.new("Dateien wiederhergestellt")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Insgesamt wurden 23 Dateien wiederhergestellt.")
	desc.wrap = true
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	return outer_box
end

def dialog_photorec_space(parent)
	moveon = false
	msg = "Der Platz auf dem Ziellaufwerk reicht nicht aus. Sie können ein weiteres USB-Laufwerk anschließen, auf welches dann Daten umkopiert werden. Klicken Sie anschließend auf \"OK\". Klicken Sie auf \"Abbrechen\", wenn Sie den Suchlauf abbrechen möchten."
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
		[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]	
	)
	dialog.default_response = Gtk::Dialog::RESPONSE_OK
	dialog.has_separator = false
	label = Gtk::Label.new(msg)
	label.wrap = true
	dialog.vbox.add(label)
	dialog.show_all
	dialog.run { |resp|
		if resp == Gtk::Dialog::RESPONSE_OK
			moveon = true
		end
		dialog.destroy
	}
	return moveon	
end

def dialog_photorec_newtarget(parent, source)
	target = nil
	cancel = true
	msg = "Wählen Sie das Laufwerk, auf welches Daten umkopiert werden sollen. Es werden nur Laufwerke mit wenigstens 1GB freiem Speicher angezeigt."
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
		[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]	
	)
	dialog.default_response = Gtk::Dialog::RESPONSE_OK
	dialog.has_separator = false
	label = Gtk::Label.new(msg)
	label.wrap = true
	dialog.vbox.add(label)
	drive_combo = Gtk::ComboBox.new
	reread = Gtk::Button.new("Neu einlesen")
	target_devs = fill_photorec_targets(drive_combo, AllDrives.new(false, false, false), source, 1_000_000_000)
	hb = Gtk::HBox.new
	hb.pack_start_defaults(drive_combo)
	hb.pack_start_defaults(reread)
	dialog.vbox.add(hb)
	dialog.show_all
	dialog.run { |resp|
		if resp == Gtk::Dialog::RESPONSE_OK
			target = target_devs[drive_combo.active] 
			cancel = false
		end
		dialog.destroy
	}
	return cancel, target
end

def photorec_move_found(recupdir, auxiliary_drive)
	blocked_raw = ` lsof | grep photorec_target/#{recupdir} `
	blocked_file = blocked_raw.split[-1]
	blocked_dir = blocked_file.split("/")[-2]
	puts "Blocked Dir: " + blocked_dir
	system("mkdir  /var/run/lesslinux/" + $$.to_s + "/photorec_auxiliary")
	system("mount " + auxiliary_drive + " /var/run/lesslinux/" + $$.to_s + "/photorec_auxiliary")
	# FIXME: Fail gracefully if only one directory exists and this does not
	# provide enough space
	copycount = 0
	0.upto(10_000) { |i|
		aux_free = ` df -k #{auxiliary_drive} | tail -n1 `.split[-3].to_i
		if File.exist?("/var/run/lesslinux/" + $$.to_s + "/photorec_target/" + recupdir + "." + i.to_s) &&
			recupdir + "." + i.to_s != blocked_dir &&
			Dir.entries("/var/run/lesslinux/" + $$.to_s + "/photorec_target/" + recupdir + "." + i.to_s).size > 2 &&
			` du -k /var/run/lesslinux/#{$$}/photorec_target/#{recupdir}.#{i.to_s} `.split[0].to_i < aux_free
			system("rsync -avHP /var/run/lesslinux/" + $$.to_s + "/photorec_target/" + recupdir + "." + i.to_s + " " +
				" /var/run/lesslinux/" + $$.to_s + "/photorec_auxiliary/")
			Dir.entries("/var/run/lesslinux/" + $$.to_s + "/photorec_target/" + recupdir + "." + i.to_s).each { |d|
				unless d == "." || d == ".."
					system("rm -rf /var/run/lesslinux/" + $$.to_s + "/photorec_target/" + recupdir + "." + i.to_s + "/" + d)
				end
			}
			system("rm -rf /var/run/lesslinux/" + $$.to_s + "/photorec_target/" + recupdir + "." + i.to_s + "/*")
			copycount += 1
		elsif File.exist?("/var/run/lesslinux/" + $$.to_s + "/photorec_target/" + recupdir + "." + i.to_s) && Dir.entries("/var/run/lesslinux/" + $$.to_s + "/photorec_target/" + recupdir + "." + i.to_s).size < 3
			puts "Empty Dir: " + " /var/run/lesslinux/" + $$.to_s + "/photorec_target/" + recupdir + "." + i.to_s
		end
	}
	system("umount /var/run/lesslinux/" + $$.to_s + "/photorec_auxiliary")
	if copycount > 0
		return true
	else
		return false
	end
end

def get_photorec_categories(photorec_ftypes, m_ftypes)
	retval = Array.new
	0.upto(photorec_ftypes.size - 1) { |i|
		retval.push(m_ftypes[i]) if photorec_ftypes[i].active? 
	}
	return retval
end

def dialog_photorec_allornothing(parent)
	moveon = false
	msg = "Wenn Sie keine Auswahl treffen, such PhotoRec nach allen ihm bekannten Dateitypen, auch nicht in der Liste verzeichnete. Dies benötigt viel Platz auf dem Ziellaufwerk und erschwert die spätere Sortierung. Klicken auf \"OK\", um nach allen Dateitypen zu suchen oder auf \"Abbrechen\", um zur Auswahl zurückzukehren."
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
		[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]	
	)
	dialog.default_response = Gtk::Dialog::RESPONSE_OK
	dialog.has_separator = false
	label = Gtk::Label.new(msg)
	label.wrap = true
	dialog.vbox.add(label)
	dialog.show_all
	dialog.run { |resp|
		if resp == Gtk::Dialog::RESPONSE_OK
			moveon = true
		end
		dialog.destroy
	}
	return moveon	
end

def get_photorec_fileopts(categories)
	fpath = "photorec_suffixes.txt"
	types = Array.new
	retstring = "everything,disable"
	File.open(fpath).each { |l|
		toks = l.strip.split
		if !toks[1].nil? && categories.include?(toks[1])
			types.push toks[0]
			retstring = retstring + "," + toks[0] + ",enable"
		end
	}
	return "everything,enable" # if types.size < 1
	# return retstring
end

def run_clean(method, progress_bars, invisible_vtes, current_drivelist, checkboxes, forw_button, back_button)
	# run_clean(method, clean_pgbars, clean_vtes)
	delete_in_progress = Hash.new
	chunk_size = 64 * 1024 * 1024
	chunk_counts = Hash.new
	sleep_count = 0
	invisible_vtes.each { |k,v|
		if checkboxes[k].active? && method == "full"
			device_size = current_drivelist.drive_list[k].blocks * current_drivelist.drive_list[k].bs
			chunk_counts[k] = ((device_size / chunk_size) + 1).to_i
			delete_in_progress[k] = true
			invisible_vtes[k].signal_connect("child-exited") { puts k + " exited!"; delete_in_progress[k] = false }
			invisible_vtes[k].fork_command("ruby", [ "ruby", "run_dd.rb", k, device_size.to_s, "/tmp/" + k.gsub("/", "_") + ".log"] )
		elsif checkboxes[k].active? && method == "fast"
			device_size = 268435456
			chunk_counts[k] = 4
			delete_in_progress[k] = true
			invisible_vtes[k].signal_connect("child-exited") { puts k + " exited!"; delete_in_progress[k] = false }
			invisible_vtes[k].fork_command("ruby", [ "ruby", "run_dd.rb", k, device_size.to_s, "/tmp/" + k.gsub("/", "_") + ".log"] )
		else
			progress_bars[k].text = "Keine Löschung"
		end
	}
	while delete_in_progress.has_value?(true) 
		forw_button.sensitive = false
		back_button.sensitive = false
		progress_bars.each { |k,v|
			if delete_in_progress[k] == true && sleep_count % 10 == 0
				# v.pulse
				chunk_num = ` tail -n1 /tmp/#{k.gsub("/", "_")}.log `.split[0].to_i
				v.fraction = chunk_num.to_f / chunk_counts[k].to_f 
				v.text = sprintf("%4.2f%", chunk_num.to_f / chunk_counts[k].to_f * 100)
				v.fraction = 1.0 if chunk_num == chunk_counts[k]
			elsif delete_in_progress[k] == false				
				v.fraction = 1.0
				v.text = "Löschung abgeschlossen"
			end
		}
		while (Gtk.events_pending?)
			Gtk.main_iteration
		end
		# puts delete_in_progress.to_s
		sleep_count += 1
		sleep 0.1
	end
	progress_bars.each { |k,v|
		if checkboxes[k].active?
			v.fraction = 1.0
			v.text = "Löschung abgeschlossen"
			system("rm /tmp/" + k.gsub("/", "_") + ".log")
		end
	}
	forw_button.sensitive = true
	back_button.sensitive = true
	return true
end

def check_network
	# Check the network by "digging" for www.computerbild.de
	# if this works, routing and name resolution should work
	return true if system("nslookup www.computerbild.de") || system("nslookup www.computerbild.de 8.8.8.8")
	return false
end

def get_networks 
	# First find interfaces:
	interfaces = Array.new
	networks = Hash.new
	IO.popen("iwconfig 2>&1") { |l|
		while l.gets
			line = $_.strip
			if line =~ /IEEE 802/
				interfaces.push(line.split[0])
			end
		end
	}
	interfaces.each { |i|
		networks[i] = Array.new
		IO.popen("iwlist " + i + " scan") { |l|
			while l.gets
				line = $_.strip
				if line =~ /^ESSID\:\"(.*?)\"/
					networks[i].push($1)
				end
			end
		}
	}
	# return { "wlan0" => [ "mattiasanja108", "bueromattias" ] }
	return networks
end

def fill_wlan_combo(combo, networks)
	99.downto(0) { |i|
		begin
			combo.remove_text(i)
		rescue
		end
	}
	best_interface = nil
	networks_found = Hash.new
	max_nets = -1
	cleaned_nets = Array.new
	networks.each { |k,v|
		networks_found[k] = 0
		v.each { |n|
			cleaned_nets.push(n)
			networks_found[k] += 1
		}
		best_interface = k if networks_found[k] > max_nets
	}
	cleaned_nets.sort.uniq.each { |n| combo.append_text(n) }
	combo.active = 0
	return best_interface
end

def dialog_nonet(parent)
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
	)
	dialog.has_separator = false
	label = Gtk::Label.new("Es wurde keine nutzbare WLAN-Schnittstelle gefunden. Die Virenprüfung findet ohne Signaturupdate statt.")
	label.wrap = true
	image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)

	hbox = Gtk::HBox.new(false, 5)
	hbox.border_width = 10
	hbox.pack_start_defaults(image);
	hbox.pack_start_defaults(label);

	# Add the message in a label, and show everything we've added to the dialog.
	# dialog.vbox.pack_start_defaults(hbox) # Also works, however dialog.vbox
                                          # limits a single item (element).
	dialog.vbox.add(hbox)
	dialog.show_all
	dialog.run
	dialog.destroy
end

def window_net_connect(parent, essid, key, buttons)
	buttons.each { |b| b.sensitive = false }
	dwin = Gtk::Window.new
	dwin.set_default_size(400, 40)
	pgbar = Gtk::ProgressBar.new
	pgbar.width_request = 300
	dwin.add(pgbar)
	dwin.deletable = false
	dwin.show_all
	ccount = 0
	netnum = -1
	system("wicd-cli --wireless -S")
	IO.popen("wicd-cli --wireless -l") { |l|
		while l.gets 
			ltoks = $_.strip.split
			netnum = ltoks[0].to_i if ltoks[3] == essid
		end
	}
	if key == ""
		system("wicd-cli --wireless -n " + netnum.to_s + " -p encryption -s False")
	else
		system("wicd-cli --wireless -n " + netnum.to_s + " -p encryption -s True")
		system("wicd-cli --wireless -n " + netnum.to_s + " -p enctype -s wpa")
		system("wicd-cli --wireless -n " + netnum.to_s + " -p encryption_method -s wpa")
		system("wicd-cli --wireless -n " + netnum.to_s + " -p key -s " + key)
	end
	connecting_active = true
	connect_vte = Vte::Terminal.new
	connect_vte.signal_connect("child-exited") { connecting_active = false }
	connect_vte.fork_command("wicd-cli", [ "wicd-cli", "--wireless", "-n", netnum.to_s, "-c" ])
	while (Gtk.events_pending?)
		Gtk.main_iteration
	end
	while connecting_active == true && ccount < 1200 
		pgbar.pulse
		sleep 0.1
		ccount += 1
		while (Gtk.events_pending?)
			Gtk.main_iteration
		end
	end
	dwin.destroy
	buttons.each { |b| b.sensitive = true }
end

def run_signature_update(vte, progbar, buttons)
	buttons.each { |b| b.sensitive = false }
	update_in_progress = true
	vte.signal_connect("child-exited") { update_in_progress = false }
	vte.fork_command("/opt/bin/freshclam", [ "/opt/bin/freshclam" ] )
	while update_in_progress == true
		sleep 0.1
		progbar.pulse
		while (Gtk.events_pending?)
			Gtk.main_iteration
		end
	end 
	buttons.each { |b| b.sensitive = true }
end

def run_clamscan(vte, progbar, buttons) 
	buttons.each { |b| b.sensitive = false }
	# Mount all drives!
	drives = AllDrives.new(false, false, false)
	scan_parts = Array.new
	drives.drive_list.each { |k,v|
		v.partitions.each { |n,p|
			if (p.fs =~ /^ntfs/ || p.fs =~ /^fat/) && p.mounted == false 
				mountpoint = p.device.gsub("/dev/", "/clamscan/")
				system("mkdir -p " + mountpoint)
				system("mount -t ntfs-3g -o ro " + p.device + " " + mountpoint) if p.fs =~ /^ntfs/
				system("mount -t vfat -o ro " + p.device + " " + mountpoint) if p.fs =~ /^fat/
				scan_parts.push(p.device)
			end	
		}
	}
	scan_in_progress = true
	vte.signal_connect("child-exited") { scan_in_progress = false }
	vte.fork_command("/opt/bin/clamscan", [ "/opt/bin/clamscan", "--log=/tmp/clamscan.log", "-r", "/clamscan" ] )
	while scan_in_progress == true
		sleep 0.1
		progbar.pulse
		while (Gtk.events_pending?)
			Gtk.main_iteration
		end
	end 
	scan_parts.each { |p| system("umount " + p) }
	buttons.each { |b| b.sensitive = true }
end



def run_kexec_memtest
	# FIXME: Unmount first!!!
	system("chvt 2")
	system("kexec --force --reset-vga /usr/share/memtest/memtest")
end

def reread_swap_drives(drives, combo)
	available_sticks = Array.new
	99.downto(0) {
		begin
			combo.remove_text(0)
		rescue
		end
	}
	drives.drive_list.each { |k,v|
		if v.attached == "usb"
			v.partitions.each { |n,p|
				if p.mounted == false && p.fs =~ /^fat/ && p.free_space > 805306368
					available_sticks.push(p.device)
					combo.append_text( v.vendor + " " + v.model + " " + (v.blocks * v.bs / 1024 / 1024 ).to_s + "MB " + p.device )
				end
			}
		end
	}
	combo.active = 0
	combo.sensitive = true
	return available_sticks
end

def create_swap(swapdev)
	puts "Creating swap on: " + swapdev
	system("mkdir /var/run/lesslinux/" + $$.to_s + "/tmp_swap")
	system("mount " + swapdev + " /var/run/lesslinux/" + $$.to_s + "/tmp_swap")
	system("dd if=/dev/zero bs=1M count=768 of=/var/run/lesslinux/" + $$.to_s + "/tmp_swap/swapfile.cry")
	system("umount /var/run/lesslinux/" + $$.to_s + "/tmp_swap")
	system("/etc/rc.d/0171-swap.sh start " + swapdev)
end

def dialog_bootsect_warn(parent)
	moveon = false
	msg = "Beim Schreiben des Bootsektors werden möglicherweise installierte Bootmanager überschrieben. Klicken Sie auf \"OK\" um fortzufahren, auf \"Abbrechen\", um den Bootsektor unangetastet zu lassen."
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
		[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]	
	)
	dialog.default_response = Gtk::Dialog::RESPONSE_OK
	dialog.has_separator = false
	label = Gtk::Label.new(msg)
	label.wrap = true
	dialog.vbox.add(label)
	dialog.show_all
	dialog.run { |resp|
		if resp == Gtk::Dialog::RESPONSE_OK
			moveon = true
		end
		dialog.destroy
	}
	return moveon	
end

def run_bootsect_restore(drives) 
	success = false
	drives.drive_list.each { |k,v|
		if v.attached == "internal"
			ospart, ostype = v.identify_windows
			bootparts = v.boot_partitions
			unless ospart.nil?
				unless bootparts.size == 1
					bootparts.each { |i|
						puts "remove boot flag from: " + i
						# partnum = i[8..-1]
						system("parted -sm " + v.device + " set " + i[8..-1] + " boot off") 
					}
					puts "set boot flag on: " + ospart 
					system("parted -sm " + v.device + " set " + ospart[8..-1] + " boot on") 
				end
				puts "write MBR for " + ostype + " on device: " + v.device
				system("dd if=/usr/share/syslinux/mbr.bin of=" + v.device)
				success = true
			end
		end	
	}
	return success
end

